/*
	0    represents    north
	1    represents    west
	2    represents    south
    3    represents    east
*/


#include <stdlib.h>
#include <time.h>
#include<iostream>
using namespace std;


unsigned int j=time(NULL);

int dir(){
	int random;
	srand(j);	  /* initialize random seed: */
	random = rand() %4;  /* generate random number: */
	j+=random+1;
	//sleep(1);
   	return random;
}

void wall_index(int prow,int pcol,int crow,int ccol,int *row,int *col){
	*row=((2*prow-1)+(2*crow-1))/2;
	*col=((2*pcol-1)+(2*ccol-1))/2;
	}
	
//getting pos
int get_pos(int cur_row,int cur_col,int tot_col){
	return (cur_row-1)*tot_col+cur_col;
}
	

//find end point
void find_end(int *row,int *col){
	if(*row%2==0 && *col%2==0){
		*row=*row/2;
		*col=*col/2;
	}
	else if(*row%2!=0 && *col%2!=0){
		*row=*row/2+1;
		*col=*col/2+1;
	}
	else if(*row%2!=0 && *col%2==0){
		*row=*row/2+1;
		*col=*col/2;
	}
	else if(*row%2==0 && *col!=0){
		*row=*row/2;
		*col=*col/2+1;
	}
}

int main()
{
	int i,k;
	int row,col,c_row,c_col,w_row,w_col;
 	cout<<"enter no. of rows";
 	cin>>row;cout<<endl;
 	c_row=row;
 	cout<<"enter no.of col";
 	cin>>col;cout<<endl;
 	c_col=col;
	char maze_out[2*row+1][2*col+1];
	int maze[row+2][col+2];	

	for(i=0;i<2*row+1;i++){
		for(k=0;k<2*col+1;k++){
			if(i%2==0 && k%2==0){
				maze_out[i][k]='+';
			}
			if(i%2!=0 && k%2!=0){
				maze_out[i][k]=' ';
			}
			if(i%2==0 && k%2!=0){
				maze_out[i][k]='-';
			}
			if(i%2!=0 && k%2==0){
				maze_out[i][k]='|';
			}
		}
	}
	
        for(int index1=0; index1<row+2 ; index1++){		
                for( int index2=0;index2<col+2;index2++){	
                        maze[index1][index2]=1;
		}
	}

       for(int index1=0 ; index1<(row+2) ; index1+=(row+1)){
                for( int index2=0;index2<(col+2);index2++){	
                        maze[index1][index2] = 0;
                    }
        }

        for(int index1=0 ; index1<(col+2) ; index1+=(col+1)){
                for( int index2=0;index2<(row+2);index2++){
                        maze[index2][index1] = 0;
                    }
	}

	//main algorithm
	int ppos=1;//present position
	int prow=1;//present row
	int pcol=1;//present col
	int dirt;
	int lpos=0;//last position
	int nrow;//new row;
	int ncol;//new col;
	maze[1][1]=2;
	find_end(&c_row,&c_col);
	int goalpos=get_pos(c_row,c_col,col);
	cout<<"dir nrow ncol maze[][] ppos lpos"<<endl;

	while(ppos!=goalpos){
	        dirt=dir();
		switch(dirt){
			case 0:
			nrow=prow-1;
			ncol=pcol;
			break;
			
			case 1:
			ncol=pcol-1;
			nrow=prow;
			break;
		
			case 2:				
	
			nrow=prow+1;
			ncol=pcol;
			break;
	
			case 3:
			ncol=pcol+1;
			nrow=prow;
			break;		
		}
	
	cout<<dirt<<"   ";
cout<<nrow<<"    "<<ncol<<"      ";
cout<<maze[nrow][ncol]<<"        ";

		if(maze[nrow][ncol]!=0){
			if(get_pos(nrow,ncol,col)!=lpos){
				maze[nrow][ncol]=2;
				wall_index(prow,pcol,nrow,ncol,&w_row,&w_col);
				maze_out[w_row][w_col]=' ';				
				lpos=ppos;
				ppos=get_pos(nrow,ncol,col);
				prow=nrow;
				pcol=ncol;
				}	
                 }
		cout<<ppos<<"   "<<lpos<<"   "<<endl;;
		}	


	
                  
cout<<endl;



	cout<<"printing maze values after algorithm"<<endl;
/*
       int index1,index2;
	for(index1=0 ; index1<(row+2) ; index1++)
	{
	     for( index2=0;index2<(col+2);index2++) 
	       {
	                cout<< maze[index1][index2] << " ";
	        }
	        cout<<endl;
        }*/
	for(i=0;i<2*row+1;i++){
		for(k=0;k<2*col+1;k++){
			cout<<maze_out[i][k]<<" ";
		}
		cout<<endl;
	}
	return 0;
}
